C     Last change:  BCM  29 Oct 2008 4:00 pm
c-----------------------------------------------------------------------
c     Table pointer variables used for prttbl and savtbl are of the form
c L<spec><type> where the spec codes are 
c-----------------------------------------------------------------------
c series         SER
c span           SPN
c transform      TRN
c regression     REG
c identification IDN or ID
c arima          ARM
c automdl        AU
c estimate       EST
c outlier        OTL
c check          CHK or CK
c forecast       FOR
c-----------------------------------------------------------------------
c and the types are
c-----------------------------------------------------------------------
c header                          HD
c span                            SP
c plot of original series        A1P
c spec file                       IN
c spectrum of original series     S0
c files to be stored/saved        SV
c prior adjustment                PA
c prior adjusted series, untrans  A3
c transformed series              DT
c trend of prior adjusted series A10
c regression matrix               DT
c regression aic test for td     ATD
c acf                            ACF
c acf plot                       ACP
c pacf                           PCF
c pacf plot                      PCP
c automatic model header         HDR
c automatic model test           MDL
c automatic model choice         MCH
c options                         OP
c iterations                      IT
c iteration errors                IE
c model                           MD
c reg correlation matrix          CM
c estimates                       ES
c arma corr matrix                AM
c statistics                      ST
c formulae                        FM
c arma roots                      RT
c regression effects              RE
c model residuals                 RS
c outlier header                  HD
c outlier iterations              IT
c outlier t-tests                 TS
c temporary ls tests              TL
c acf                            ACF
c acf plot                       ACP
c pacf                           PCF
c pacf plot                      PCP
c histogram                      HST
c transformed scale               TS # or tests
c variances                       VR
c original scale                  OS
c-----------------------------------------------------------------------
      INTEGER LSRSHD,LSRSSP,LSRA1P,LSRSIN,LSRSS0,LSRSSV,LSRSMV,LSRA18,
     &        LSRA19,LSRSB1,LSRB1P,LTRSCN,LTRACP,LTRNPA,LTRA2P,LTRA2T,
     &        LTRNA3,LTRA3P,LTRA4D,LTRA4P,LTRNDT,LTRAIC,LREGDT,LRGATS,
     &        LRGOTL,LREGAO,LREGLC,LREGTC,LREGTD,LRGHOL,LRGUSR,LRGA10,
     &        LRGTDW,LIDACF,LIDACP,LIDPCF,LIDPCP,LIDRGC,LAUHDR,LAUURT,
     &        LAUMCH,LAUURM,LAUMDL,LAUB5M,LAUOTH,LAUOTI,LAUOTT,LAUOFT,
     &        LAUDFT,LAUFLB,LAUFNT,LAXHDR,LAXMDL,LAXMCH,LESTOP,LESTIT,
     &        LESTIE,LESTMD,LESTCM,LESTES,LESTAM,LESTST,LESTFM,LESTRT,
     &        LESTRE,LESTRS,LESAFC,LOTLHD,LOTLIT,LOTLTS,LOTLTL,LOTLFT,
     &        LCKACF,LCKPCF,LCKAC2,LCKHST,LCKNRM,LCKSPR,LFORTS,LFORVR,
     &        LFOROS,LFORTB,LFORBC
      PARAMETER(
     &          LSRSHD=1,LSRSSP=2,LSRA1P=3,LSRSIN=4,LSRSS0=5,LSRSSV=6,
     &          LSRSMV=7,LSRA18=8,LSRA19=9,LSRSB1=10,LSRB1P=11,
     &          LTRSCN=12,LTRACP=13,LTRNPA=14,LTRA2P=15,LTRA2T=16,
     &          LTRNA3=17,LTRA3P=18,LTRA4D=19,LTRA4P=20,LTRNDT=21,
     &          LTRAIC=22,LREGDT=23,LRGATS=24,LRGOTL=25,LREGAO=26,
     &          LREGLC=27,LREGTC=28,LREGTD=29,LRGHOL=30,LRGUSR=31,
     &          LRGA10=32,LRGTDW=33,LIDACF=34,LIDACP=35,LIDPCF=36,
     &          LIDPCP=37,LIDRGC=38,LAUHDR=39,LAUURT=40,LAUMCH=41,
     &          LAUURM=42,LAUMDL=43,LAUB5M=44,LAUOTH=45,LAUOTI=46,
     &          LAUOTT=47,LAUOFT=48,LAUDFT=49,LAUFLB=50,LAUFNT=51,
     &          LAXHDR=52,LAXMDL=53,LAXMCH=54,LESTOP=55,LESTIT=56,
     &          LESTIE=57,LESTMD=58,LESTCM=59,LESTES=60,LESTAM=61,
     &          LESTST=62,LESTFM=63,LESTRT=64,LESTRE=65,LESTRS=66,
     &          LESAFC=67,LOTLHD=68,LOTLIT=69,LOTLTS=70,LOTLTL=71,
     &          LOTLFT=72,LCKACF=73,LCKPCF=75,LCKAC2=77,LCKHST=79,
     &          LCKNRM=80,LCKSPR=81,LFORTS=82,LFORVR=83,LFOROS=84,
     &          LFORTB=85,LFORBC=86)
