C     Last change:  BCM  29 Oct 2008 4:01 pm
c-----------------------------------------------------------------------
c     Table pointer variables used for prttbl and savtbl are of the form
c L<spec><type> where the spec codes are 
c-----------------------------------------------------------------------
c composite      CMP, CP
c-----------------------------------------------------------------------
c and the types are
c-----------------------------------------------------------------------
c aggregate series                  A1
c spectrum of original series       S0
c aggheader                         AH
c aggtest                           AT
c indirect d8                       D8
c indirect d9                       D9
c indirect seasonal                 SF
c indirect final seasonal diff.    FSD
c indirect seasonally adjusted      SA
c indirect trend                    TRN
c indirect irregular                IRR
c indirect e1                       E1
c indirect e2                       E2
c indirect e3                       E3
c indirect change original srs      E5
c indirect change sa                E6
c indirect change adjusted sa       E6A
c indirect change rounded sa        E6R
c indirect mcd moving avg           F1
c indirect x11 diagnostics          F2
c indirect q stats                  F3
c indirect yearly totals            E4
c indirect ftest d8                 D8F
c indirect moving seasonality ratio D9A
c indirect residual seas f-test     RSF
c indirect adjusted fin seas adj    SAA
c indirect rounded fin seas adj     RND
c spectrum of ind sa series         S1
c spectrum of ind mod irregular     S2
c original series                   A1P
c series vrs. ind sa series         E0
c ratios of ind series              R1
c ratios of ind sa series           R2
c ind final seasonal factors        SP
c ind final seasonally adj.         AP
c ind final trend component         TP    
c ind final irregular component     IP
c-----------------------------------------------------------------------
      INTEGER LCMPA1,LCMPA3,LCMPB1,LCPB1P,LCPA18,LCPA19,LCMPS0,LCMPAH,
     &        LCMPAT,LCMPD8,LCMPD9,LCMPSF,LCPIPS,LCPFSD,LCMPSA,LCPTRN,
     &        LCPIRR,LCPIPI,LCMPE1,LCMPE2,LCMPE3,LCMPE5,LCPE5P,LCMPE6,
     &        LCPE6P,LCPE6A,LCP6AP,LCPE6R,LCP6RP,LCMPE7,LCPE7P,LCMPE8,
     &        LCPE8P,LCPE11,LCPE18,LCPEEB,LCMPF1,LCMPF2,LCMPF3,LCMPE4,
     &        LCPD8F,LCPD9A,LCPRSF,LCPSAA,LCPRND,LCMPS1,LCMPS2,LCPA1P,
     &        LCMPE0,LCMPR1,LCMPR2,LCMPSP,LCMPAP,LCMPTP,LCMPIP,LCPILS,
     &        LCPIAO,LCPFCF,LCPCAF,LCPIPA,LCPCRI,LCPRRI,LCPFFC
      PARAMETER(
     &          LCMPA1=254,LCMPA3=255,LCMPB1=256,LCPB1P=257,LCPA18=258,
     &          LCPA19=259,LCMPS0=260,LCMPAH=261,LCMPAT=262,LCMPD8=263,
     &          LCMPD9=264,LCMPSF=265,LCPIPS=266,LCPFSD=267,LCMPSA=268,
     &          LCPTRN=269,LCPIRR=270,LCPIPI=271,LCMPE1=272,LCMPE2=273,
     &          LCMPE3=274,LCMPE5=275,LCPE5P=276,LCMPE6=277,LCPE6P=278,
     &          LCPE6A=279,LCP6AP=280,LCPE6R=281,LCP6RP=282,LCMPE7=283,
     &          LCPE7P=284,LCMPE8=285,LCPE8P=286,LCPE11=287,LCPE18=288,
     &          LCPEEB=289,LCMPF1=290,LCMPF2=291,LCMPF3=292,LCMPE4=293,
     &          LCPD8F=294,LCPD9A=295,LCPRSF=296,LCPSAA=297,LCPRND=298,
     &          LCMPS1=299,LCMPS2=300,LCPA1P=301,LCMPE0=302,LCMPR1=303,
     &          LCMPR2=304,LCMPSP=305,LCMPAP=306,LCMPTP=307,LCMPIP=308,
     &          LCPILS=309,LCPIAO=310,LCPFCF=311,LCPCAF=312,LCPIPA=313,
     &          LCPCRI=314,LCPRRI=315,LCPFFC=316)
