C     Last change:  BCM  18 Oct 2004 12:18 pm
      SUBROUTINE xpand(B,Mxarlg,Na,Nc,C)
      IMPLICIT NONE
c-----------------------------------------------------------------------
c     FORTRAN corrections made by Bill Bell -- 9/10/92
c 1. Integer declaration statement put before double precision declaration
c    statement
c 2. Variable name "O" changed to "m" for clarity
c 3. REAL B(P) changed to double precision B(max(P,1)) to handle case
c    where P = 0
c 4. REAL A(m:Na) changed to double precision A(m:max(Na,1))
c    to handle case where Na = 0
c Changes made:  9/21/92,  Bill Bell
c 1. IMPLICIT NONE   statement added
c 2. REAL type statements changed to DOUBLE PRECISION
c-----------------------------------------------------------------------
      INCLUDE 'srslen.prm'
      INCLUDE 'model.prm'
      DOUBLE PRECISION ZERO
      PARAMETER(ZERO=0D0)
c     ------------------------------------------------------------------
      INTEGER i,Mxarlg,Na,Nc,nlag,w
      DOUBLE PRECISION a(0:PORDER),B(0:Mxarlg),C(0:PORDER),sum
c-----------------------------------------------------------------------
c     Calculates the expansion of A(Z)/B(Z) = C(Z) up to order nc.
c-----------------------------------------------------------------------
      CALL copy(C,Na+1,1,a)
c     ------------------------------------------------------------------
      DO i=0,Nc
       nlag=min(Mxarlg,i)
c     ------------------------------------------------------------------
       IF(i.le.Na)THEN
        sum=a(i)
       ELSE
        sum=ZERO
       END IF
c     ------------------------------------------------------------------
       DO w=1,nlag
        sum=sum-B(w)*C(i-w)
       END DO
c     ------------------------------------------------------------------
       C(i)=sum
      END DO
c     ------------------------------------------------------------------
      RETURN
      END
